#include "mbed.h"
#include "vga640x480g.h"

#define FONTHEIGHT 16
#define FONTWIDTH 8

int console_x=0, console_y=0;
int console_color=WHITE; //text color

DigitalOut myled(LED1);

Serial serial(USBTX,USBRX);

void rawputc(char c)
{
    //fuck that shitv
    if(console_x>80)
    {
        return;
    }
    //shift left for fast multiply
    vga_putchar(console_x<<3, console_y<<4, c, console_color);
}
void putc(char c)
{
    //shift left for fast multiply
    if(console_x>=79)
    {
        console_x=0;
        console_y++;
    }
    switch(c){
        case '\n':
        case '\r':
        console_y++;
        console_x=0;
        break;
        case '\b':
        rawputc(' ');
        if(console_x>0)
        {
            console_x--;
        }
        rawputc(' ');
        break;
        case '\t':
        for(int i=0;i<4;i++)
        {
            console_x++;
            rawputc(' ');
        }
        default:
        vga_putchar(console_x<<3, console_y<<4, c, console_color);
        console_x++;
    }
}

/*void puts(char *s){
    while(*s!=0){
        char c=*s;
        switch(c)
            case '\n':
            case '\r':
            console_x=0;
        vga_putchar(console_x,console_y,*s,console_color);
    }
*/

int main() {
    init_vga();

    serial.baud(115200);
    
    vga_cls();
    
    while(1)
    {
        if(serial.readable()){
            putc(serial.getc());
        }
    }
}
